Index: trunk/expressoMail1_2/js/search.js
===================================================================
--- trunk/expressoMail1_2/js/search.js	(revision 7386)
+++ trunk/expressoMail1_2/js/search.js	(revision 7414)
@@ -1,3 +1,5 @@
 	xhr = false;
+
+	var folder 		= {};
 	
 	function searchE()
@@ -144,47 +146,42 @@
 	}
 	
+	//draws folder list
 	searchE.prototype.foldersTree = function()
 	{
-		var treeFoldersSearch = new dFTree({name : 'treeFoldersSearch'});
-		
-		var root	= new dNode({id : 'root', caption: get_lang('My Folders'), onClick: "ttree.setFolder('root')"});
-		
-		treeFoldersSearch.add(root, 'root');
-
-		for(var i = 0; i < folders.length ; i++ )
-		{
-			var nn = new dNode({id:folders[i].folder_id, caption: lang_folder(folders[i].folder_name), plusSign:folders[i].folder_hasChildren, onClick: "ttree.setFolder('"+folders[i].folder_id+"')"});
+		/*Insere a árvore de diretórios*/
+
+		var foldersTree = jQuery("#divFoldersSearch")
+		.removeClass('empty-container')
+		.html(DataLayer.render(BASE_PATH + 'api/templates/foldertree.ejs', {folders: [cp_tree1, cp_tree2, cp_tree3 ]}))
+		.find("#foldertree").treeview()
+		.click(function(event)
+		{
+			//request new selected folder messages
+			var target = $(event.target);
+
+			if( target.is('.collapsable-hitarea, .expandable-hitarea, .lastCollapsable, .lastExpandable, .treeview') )
+			    return;
+
+			if( !target.attr('id') )
+			    target = target.parent();
+
+	        if (target.attr('id') == "foldertree") return;
 			
-			if ( folders[i].folder_parent == '' )
-			{
-				folders[i].folder_parent = 'root';
-			}
-            else if ( folders[i].folder_parent.indexOf('user') != -1 )
-            {
-            	//if ( treeFoldersSearch.getNodeById('user') )
-            	{
-            		var n_root_shared_folders = new dNode({id:'user', caption:get_lang("Shared Folders"), plusSign:true});
-                    treeFoldersSearch.add( n_root_shared_folders,'root');
-                }
-            }
-
-			// Ver Ticket #1548
-			if( folders[i].folder_parent != 'root')
-			{
-                var node_parent = treeFoldersSearch.getNodeById(folders[i].folder_parent);
-                
-                if( typeof node_parent != 'undefined')
-                {
-                	node_parent.plusSign = true;
-                	treeFoldersSearch.alter(node_parent);
-                }
-            }
+			folder 			= {};
+			folder.id 		= target.attr('id');
+			folder.child 	= target.find('.folder');
+			folder.caption	= target.find('span').attr('title');			
 			
-			treeFoldersSearch.add( nn, folders[i].folder_parent );
-		}
-
-		treeFoldersSearch.draw( $("#divFoldersSearch")[0] );
-		treeFoldersSearch.getNodeById("root")._select();
-		root.changeState();
+			$('.filetree span.folder.selected').removeClass('selected');
+			if(!target.is('#foldertree > .expandable, #foldertree > .collapsable'))
+				$(target).children('.folder').addClass('selected');
+
+			selectedFolder = {
+			    id: folder.id, 
+			    name: folder.child.attr('title'),
+			    'class': folder.child.attr('class')
+			};
+		});
+
 	}
 	
@@ -413,4 +410,5 @@
 	searchE.prototype.viewLocalMessage = function()
 	{
+		/*
 		var data		  	= [2];
 		var gears			= [];
@@ -449,4 +447,18 @@
 						
 			EsearchE.mount_result( data, 'SORTDATE' );
+		}
+		*/
+
+		var data		  	= [2];
+		var gears			= [];
+		var local_folders	= [];
+         
+    	//MailArchiver - local data
+        if ( preferences.use_local_messages == 1 )
+		{
+        	data['data_gears']	= expresso_mail_archive.search_queryresult;
+            data['num_msgs']	= expresso_mail_archive.search_queryresult.length;
+	        write_msg( data['num_msgs'] + " " + get_lang("results found"));
+			EsearchE.mount_result(data , 'SORTDATE');
 		}
 	}
@@ -545,120 +557,124 @@
 			if (j == 4)
 			{
-				td.setAttribute("width", colSizes[1][4]);
-				td.id = "td_message_followup_search_"+uid_msg;
-				td.setAttribute("class","search-result-item");
-				td1 = '<div class="flag-edited" style="width:8px;height:6px;"><img src="../prototype/modules/mail/img/flagEditor.png"></div>';
+				if(border_id.split("local").length == 1){
+					td.setAttribute("width", colSizes[1][4]);
+					td.id = "td_message_followup_search_"+uid_msg;
+					td.setAttribute("class","search-result-item");
+					td1 = '<div class="flag-edited" style="width:8px;height:6px;"><img src="../prototype/modules/mail/img/flagEditor.png"></div>';
+							
+					$(td).click(function(event, ui){	
+						var messageClickedId = $(this).attr('id').match(/td_message_followup_search_([\d]+)/)[1];
 						
-				$(td).click(function(event, ui){	
-					var messageClickedId = $(this).attr('id').match(/td_message_followup_search_([\d]+)/)[1];
+						var followupColor = $('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css('backgroundColor');
+						
+						$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
+						.html('<img alt="Carregando" title="Carregando" style="margin-left:-3px; margin-top:-4px; width:13px; height:13px;" src="../prototype/modules/mail/img/ajax-loader.gif" />');	
+							
+						$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", "transparent");
+			
+						/**TODO Alterar após melhorias no filtro da camada javascript*/
+						DataLayer.remove('followupflagged', false);
+						var flagged = DataLayer.get('followupflagged', {filter: [
+							'AND', 
+							['=', 'messageNumber', messageClickedId], 
+							['=', 'folderName', mailbox]
+						]});
+						if(flagged == '' || flagged == [] || flagged == 'undefined'){
+							/**
+							* Aplica followupflag de Acompanhamento
+							*/
+							aux.followupflagged = {
+								uid : User.me.id,
+								folderName : mailbox, 
+								messageNumber : messageClickedId, 
+								alarmTime : false, 
+								backgroundColor : '#FF2016',
+								followupflagId: '1'
+							};
 					
-					var followupColor = $('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css('backgroundColor');
-					
-					$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-					.html('<img alt="Carregando" title="Carregando" style="margin-left:-3px; margin-top:-4px; width:13px; height:13px;" src="../prototype/modules/mail/img/ajax-loader.gif" />');	
-						
-					$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", "transparent");
-		
-					/**TODO Alterar após melhorias no filtro da camada javascript*/
-					DataLayer.remove('followupflagged', false);
-					var flagged = DataLayer.get('followupflagged', {filter: [
-						'AND', 
-						['=', 'messageNumber', messageClickedId], 
-						['=', 'folderName', mailbox]
-					]});
-					if(flagged == '' || flagged == [] || flagged == 'undefined'){
-						/**
-						* Aplica followupflag de Acompanhamento
-						*/
-						aux.followupflagged = {
-							uid : User.me.id,
-							folderName : mailbox, 
-							messageNumber : messageClickedId, 
-							alarmTime : false, 
-							backgroundColor : '#FF2016',
-							followupflagId: '1'
-						};
-				
-						aux.followupflagged.id = DataLayer.put('followupflagged', aux.followupflagged);
-						DataLayer.commit(false, false, function(data){
-							var fail = false;
-							$.each(data, function(index, value) {
-								fail = false;
-								if(typeof value === 'string'){
-									fail = value;
+							aux.followupflagged.id = DataLayer.put('followupflagged', aux.followupflagged);
+							DataLayer.commit(false, false, function(data){
+								var fail = false;
+								$.each(data, function(index, value) {
+									fail = false;
+									if(typeof value === 'string'){
+										fail = value;
+									}
+								});
+								
+								$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
+								.html('<img src="../prototype/modules/mail/img/flagEditor.png">');
+								
+								if (fail) {
+								    
+								    var isCurrentFolder = current_folder == mailbox ? '#td_message_followup_' + messageClickedId + ', ' : ''; 	
+								    $(isCurrentFolder + 'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", "#CCCCCC");
+								    MsgsCallbackFollowupflag[fail]();
+								    return false;
+								}
+								
+								if(current_folder == mailbox){
+									$('#td_message_followup_' + messageClickedId + ', ' + 
+									'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', get_lang('Follow up')).find(".flag-edited").css("background", aux.followupflagged.backgroundColor);	
+								}else{								
+									$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', get_lang('Follow up')).find(".flag-edited").css("background", aux.followupflagged.backgroundColor);		
+								}								
+								updateCacheFollowupflag(messageClickedId, mailbox, true);
+							});
+
+							
+						}else if(onceOpenedHeadersMessages[mailbox][messageClickedId]['followupflagged'].followupflag.name == 'Follow up'){
+							/**
+							* Remover followupflag de Acompanhamento (DFD0078:RI25)
+							*/
+							$(this).find(".flag-edited").css("background", "#cccccc");
+							DataLayer.remove('followupflagged', flagged[0].id );
+							DataLayer.commit(false, false, function(){
+								$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
+								.html('<img src="../prototype/modules/mail/img/flagEditor.png">');
+								if(current_folder == mailbox){
+									updateCacheFollowupflag(messageClickedId, mailbox, false);
+								
+									$('#td_message_followup_' + messageClickedId + ', ' + 
+									  'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', '').find(".flag-edited").css("background", '#CCC');
+									
+									$('#td_message_followup_' + messageClickedId + ', ' + 
+										'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
+										.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");			
+								}else{
+									updateCacheFollowupflag(messageClickedId, mailbox, false);
+									
+									$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', '').find(".flag-edited").css("background", '#CCC');
+									
+									$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
+										.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");
 								}
 							});
-							
+
+						} else {
 							$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
 							.html('<img src="../prototype/modules/mail/img/flagEditor.png">');
-							
-							if (fail) {
-							    
-							    var isCurrentFolder = current_folder == mailbox ? '#td_message_followup_' + messageClickedId + ', ' : ''; 	
-							    $(isCurrentFolder + 'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", "#CCCCCC");
-							    MsgsCallbackFollowupflag[fail]();
-							    return false;
-							}
-							
-							if(current_folder == mailbox){
-								$('#td_message_followup_' + messageClickedId + ', ' + 
-								'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', get_lang('Follow up')).find(".flag-edited").css("background", aux.followupflagged.backgroundColor);	
-							}else{								
-								$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', get_lang('Follow up')).find(".flag-edited").css("background", aux.followupflagged.backgroundColor);		
-							}								
-							updateCacheFollowupflag(messageClickedId, mailbox, true);
-						});
-
-						
-					}else if(onceOpenedHeadersMessages[mailbox][messageClickedId]['followupflagged'].followupflag.name == 'Follow up'){
-						/**
-						* Remover followupflag de Acompanhamento (DFD0078:RI25)
-						*/
-						$(this).find(".flag-edited").css("background", "#cccccc");
-						DataLayer.remove('followupflagged', flagged[0].id );
-						DataLayer.commit(false, false, function(){
-							$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-							.html('<img src="../prototype/modules/mail/img/flagEditor.png">');
-							if(current_folder == mailbox){
-								updateCacheFollowupflag(messageClickedId, mailbox, false);
-							
-								$('#td_message_followup_' + messageClickedId + ', ' + 
-								  'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', '').find(".flag-edited").css("background", '#CCC');
-								
-								$('#td_message_followup_' + messageClickedId + ', ' + 
-									'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-									.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");			
-							}else{
-								updateCacheFollowupflag(messageClickedId, mailbox, false);
-								
-								$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).attr('title', '').find(".flag-edited").css("background", '#CCC');
-								
-								$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-									.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");
-							}
-						});
-
+							$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", followupColor);
+							$(this).parents('[role="'+messageClickedId+'_'+mailbox+'"]').attr('class', 'selected_msg').find(':checkbox').trigger('click');
+							configureFollowupflag();
+						}
+						//if(!){}
+
+					});		
+				}		
+			}
+			if (j == 5)
+			{
+				if(border_id.split("local").length == 1){
+					td.setAttribute("width", colSizes[1][5]);
+					td.id = "td_message_labels_search_"+uid_msg;
+					td.setAttribute("class","td-label-search");				
+					
+					if (aux.labels) {
+						td1 = '<img src="../prototype/modules/mail/img/tag.png">';
+						updateLabelsColumn(aux)		
 					} else {
-						$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited")
-						.html('<img src="../prototype/modules/mail/img/flagEditor.png">');
-						$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", followupColor);
-						$(this).parents('[role="'+messageClickedId+'_'+mailbox+'"]').attr('class', 'selected_msg').find(':checkbox').trigger('click');
-						configureFollowupflag();
+						td1 = '';
 					}
-					//if(!){}
-
-				});				
-			}
-			if (j == 5)
-			{
-				td.setAttribute("width", colSizes[1][5]);
-				td.id = "td_message_labels_search_"+uid_msg;
-				td.setAttribute("class","td-label-search");				
-				
-				if (aux.labels) {
-					td1 = '<img src="../prototype/modules/mail/img/tag.png">';
-					updateLabelsColumn(aux)		
-				} else {
-					td1 = '';
 				}
 			}
@@ -735,6 +751,5 @@
 				td.onclick		= _onclick;
 
-				if( validate_date( aux.udate ) )
-				{
+				if(validate_date(new String(aux.udate))){
 					var td1 = aux.udate;
 				}
@@ -1256,4 +1271,7 @@
 		if(typeof(Data.data_gears)=="undefined")
 			EsearchE.show_paging( Data['num_msgs'] );
+
+		Data = null;
+		data = null;
 	}
 
@@ -1275,4 +1293,5 @@
 	{
 		var sel = Element("sel_search_nm_box1");
+		this.name_box_search = folder.id;
 		
 		if (!proxy_mensagens.is_local_folder(this.name_box_search))
@@ -1298,6 +1317,7 @@
 				name_box_def = this.name_box_search.substr(final_pos+1);
 			}
-			else
-				name_box_def = this.name_box_search.substr(6);//Retira o 'local_'
+			else {
+				name_box_def = folder.caption + " (local)"; //this.name_box_search.substr(6);//Retira o 'local_'
+			}
 		}
 		
@@ -1490,9 +1510,5 @@
 			if (preferences.use_local_messages == 1)
 			{
-				temp = expresso_local_messages.list_local_folders();
-				for (var x in temp)
-				{
-					local_folders.push(temp[x][0]);
-				}
+				local_folders[0] = ""; //se local_folders[0] estiver vazio, busca em todas as pastas
 			}
 		}
@@ -1566,5 +1582,7 @@
 			{
 				expresso_local_messages.setSortType('SORTDATE');
-				tmp = expresso_local_messages.search( local_folders, fields );
+				//tmp = expresso_local_messages.search( local_folders, fields );
+				expresso_mail_archive.search(local_folders, fields);
+				tmp = expresso_mail_archive.search_queryresult;
 			}
 
@@ -1575,7 +1593,11 @@
 			}
 
-			if ( tmp.length > 0 )
-			{
-				allMsg['gears_num_msgs'] = tmp.length ;
+			if (tmp) {
+				if ( tmp.length > 0 )
+				{
+					allMsg['gears_num_msgs'] = tmp.length ;
+				}
+			} else {
+				allMsg['gears_num_msgs'] = 0;
 			}
 
@@ -1586,5 +1608,5 @@
 			else
 			{
-				if( ( tmp.length > 0) && ( !data['num_msgs'] ) ) 
+				if( ( tmp && tmp.length > 0) && ( !data['num_msgs'] ) ) 
 				{
 					EsearchE.viewLocalMessage();
@@ -1596,5 +1618,4 @@
 						EsearchE.func_clean();
 					}
-					
 					write_msg( count + " " + get_lang("results found") );
 					
@@ -1646,5 +1667,5 @@
 	searchE.prototype.quickSearchMail = function(value, page, sort, border_id)
 	{
-		var local_folders = new Array();
+		var local_folders = new Array;
 		var temp;
 		var not_found_corrent_folder = true;
@@ -1657,12 +1678,7 @@
 		}
 		
+		//Inserido valor vazio no array para representar todas as pastas locais
 		if (preferences.use_local_messages == 1)
-		{
-			temp = expresso_local_messages.list_local_folders();
-			for (var x in temp)
-			{
-				local_folders.push(temp[x][0]);
-			}
-		}
+			local_folders.push("");
 
 		this.sort		= sort || this.sort || "SORTDATE";
@@ -1711,5 +1727,6 @@
 			    write_msg( "pesquisando " + labels[0] + link, true );
 			    var keepFilled = false;
-			    
+			    //Inserida variável de controle para correta manipulação das mensagens locais
+			    var local_messages_link = true;
 
 			    var handler = function( data )
@@ -1723,23 +1740,22 @@
 					};
 
-					// Gears - local
-					if ( local_folders.length > 0 ){
-						expresso_local_messages.setSortType('SORTDATE');
-						var tmp = expresso_local_messages.search( local_folders, "##ALL <=>" + url_encode(value) + "##" ); 
-
-						if( tmp.length > 0 )
-							if( !allMsg['num_msgs'] ){
-								clean_msg();
-							    not_found_corrent_folder = false;
-								if(tmp.length)
-									allMsg['gears_num_msgs'] = tmp.length;
-							}else
-								allMsg['gears_num_msgs'] = tmp.length;
-        }
-
-					if( !allMsg['num_msgs'] && !url.length && not_found_corrent_folder){
-						clean_msg();
-						return EsearchE.viewLocalMessage();
-					}
+					//MAILARCHIVER
+	                if(local_messages_link){ //Código executado apenas na primeira vez.
+		                if ( local_folders.length > 0 ){
+		                    expresso_mail_archive.search_queryresult = null; //Limpa a variável global para não exibir resultados anteriores
+		                    expresso_mail_archive.search(local_folders, "##ALL <=>" + url_encode(value) + "##");
+		                    tmp = expresso_mail_archive.search_queryresult;
+		                    if(tmp == null){
+		                        tmp = new Object();
+		                        tmp.length = 0;
+		                    }
+		                }
+		                EsearchE.localResults = tmp.length;
+
+		                if( tmp.length > 0 )
+		                {
+		                    allMsg['gears_num_msgs'] = tmp.length ;
+		                }
+	                }
 
 					if( allMsg['num_msgs'] )
@@ -1754,4 +1770,6 @@
 							async: true,
 							success: function(data){
+								//Inserida variável de controle para correta manipulação das mensagens locais
+								local_messages_link = false;
 								handler(data);
 							},
@@ -1759,5 +1777,5 @@
 								connector.showProgressBar();
 							},
-							  complete: function( jqXHR, settings ){
+							complete: function( jqXHR, settings ){
 								connector.hideProgressBar();
 							}
@@ -1769,5 +1787,5 @@
 					
 			    }
-			    
+
 			    xhr = $.ajax({
 				url: 'controller.php?action='+url.shift(),
